package com.contextspace.objectdb_example.dao.impl;

import java.util.List;

import javax.persistence.TypedQuery;

import org.springframework.stereotype.Repository;

import com.contextspace.objectdb_example.dao.IAttributeNameDAO;
import com.contextspace.objectdb_example.dao.exception.DaoException;
import com.contextspace.objectdb_example.model.AttributeName;


@Repository
public class AttributeNameDAOImpl extends BaseDAOImpl<AttributeName , Long> implements IAttributeNameDAO{

	public AttributeName GetByName(String name) throws DaoException {
		if(name != null && !name.equals("")) {
			TypedQuery<AttributeName> query = em().createQuery(
					"SELECT an FROM AttributeName an where name=:attName", AttributeName.class);
			query.setParameter("attName", name);
			
			List<AttributeName> result = query.getResultList();
			
			if(!result.isEmpty()) {
				return result.get(0);
			}
		}
		
		return null;
	}
	

	public boolean IsNameAvailable(String name) throws DaoException {
		if(name != null && !name.equals("")) {
			TypedQuery<AttributeName> query = em().createQuery(
					"SELECT an.name FROM AttributeName an where name:attName", AttributeName.class);
			query.setParameter("attName", name);
			
			List<AttributeName> result = query.getResultList();
			
			if(result.isEmpty()) {
				return true;
			} else {
				return false;
			}
		} else {
			throw new DaoException("Attribute Name may not be empty.");
		}
	}
	
}
